import Timer/Periodic

Class WebPoller 

WebPoller instproc init { dir url options } {
	$self instvar dir_ url_ options_ 

	set dir_ $dir
	set url_ $url
	set options_ $options
}

WebPoller instproc init_trace { filename } {
	$self instvar tracef_ starttime_
	
	set tracef_ [open $filename w]
	set starttime_ [clock seconds]
}

WebPoller instproc trace { name len } {
	$self instvar tracef_ starttime_
	if [info exists tracef_] {
		set now [expr [clock seconds] - $starttime_]
		puts "$now $name $len"
		puts $tracef_ "$now $name $len"
	}
}

WebPoller instproc get { { path "" } } {
	$self instvar dir_ url_ options_ buffer_

	if { $path != "" } {
		set url "$url_/$path"
		set dump "$dir_/$path"
	} else {
		set url $url_
		set dump "$dir_/index.html"
	}
	makedir [file dirname $dump]
	set out [open $dump w]
	set token [::http::geturl $url -channel $out -headers $options_] 
	set status [::http::status $token]
	close $out
	
	if { "$status" == "ok" } {
		$self handle $dump $path
	} 
}

proc makedir { pathname } {
	if { [file isdirectory $pathname] } {
		return $pathname
	} elseif { [file exists $pathname] } {
		return ""
	} else {
		makedir [file dirname $pathname]
		exec mkdir $pathname
		return $pathname
	}
}

WebPoller instproc handle { filename } {
	puts "filename: $filename"
}


Class WebPollerTimer -superclass Timer/Periodic

WebPollerTimer instproc init { app callback period } {
	$self instvar app_ callback_ 
	
	set app_ $app
	set callback_ $callback
	$self next

	$self timeout
	$self start $period
}

WebPollerTimer instproc timeout { } {
	$self instvar app_ callback_

	eval [list $app_ $callback_]
}

Class WebPoller/Periodic -superclass WebPoller

WebPoller/Periodic instproc init_timer { period } {
	$self instvar timer_
	
	set timer_ [new WebPollerTimer $self "get" $period]
}

WebPoller/Periodic instproc stop { } {
	$self instvar timer_ tracef_

	if [info exists tracef_] {
		flush $tracef_
		close $tracef_
	}
	$timer_ cancel

	exit
}







